import processing.pdf.*;

String fullText[];
ArrayList sceneLocation = new ArrayList();
ArrayList characterNames = new ArrayList();
ArrayList playSummary = new ArrayList(); //Acts and points where characters speak, but without lines

int playLength;//Length of play in lines
float screenPlayRatio;//Ratio of play length to screen width
int lineThickness = 2;//Thickness of CharacterLines
int screenPaddingX = 80; //Padding on left and right edges
int screenPaddingTop = 40; //Distance from top;

void setup() {
  //size(2500, 720, PDF, "filename.pdf");//Commented out to display results rather than record PDF
  size(2500, 720);
  smooth();
  //fullText = loadStrings("data/AMIDSUMMERNIGHTSDREAM.txt"); //Full text of all play
  //fullText = loadStrings("data/KINGHENRYTHEEIGHTH.txt"); //Full text of all play
  fullText = loadStrings("data/THETRAGEDYOFTITUSANDRONICUS.txt"); //Full text of all play
  
  findScenes();
  findPeople();
  playLength = fullText.length - Integer.parseInt((String)sceneLocation.get(0));
  screenPlayRatio = ((float) (width - screenPaddingX))/playLength;
  //screenPlayRatio = ((float) (width - screenPaddingX))/3849; //Using fixed number for comparitive play length
  println("SPR: " + screenPlayRatio);
  //beginRecord(PDF, "AMIDSUMMERNIGHTSDREAM.pdf");
  //beginRecord(PDF, "KINGHENRYTHEEIGHTH.pdf");
  //beginRecord(PDF, "THETRAGEDYOFTITUSANDRONICUS.pdf"); //Commented out to display results rather than record PDF
  drawScenes(); //Not yet impl
  drawCharacterLines();  
  //endRecord();  //Commented out to display results rather than record PDF
}

void findScenes(){
  for (int i=0; i < fullText.length; i++){
   String[] container= match(fullText[i], "SCENE\\s{1}"); //Find date in line - All plays begin with a date 
   if (container != null){
     sceneLocation.add(Integer.toString(i));  //ArrayLists dont like ints >.<
     println("Scene " + sceneLocation.size() + " begins at line " + i);
   }  
  }
}

void findPeople(){
  for (int i=0; i < fullText.length; i++){
   String[] container= match(fullText[i], "(^[A-Z]*\\s?[A-Z]*\\s?[A-Z]*)+\\."); //Find name 
   if (container != null){
     characterNames.add(split(container[0], ".")[0]);  //Strips the "." from the name of the Characters and places name in to ArrayList
   }  
  }
  
  playSummary = (ArrayList) characterNames.clone();
  
  //Strip ACT and SCENE from list
  for(int i=0; i < characterNames.size(); i++){
    String currentCharacterName = (String) characterNames.get(i); //get first name in list
    String[] container= match(currentCharacterName, "^SCENE+");
    if (container != null){
      characterNames.remove(i);
    }
    else{
      container= match(currentCharacterName, "^ACT+");
      if (container != null){
        characterNames.remove(i);
      }
    }
  }

  //Find unique character names
  for(int i=0; i < characterNames.size(); i++){
   String currentCharacterName = (String) characterNames.get(i); //get first name in list
   
   for(int j=0; j < characterNames.size(); j++){
     String comparedCharacterName = (String) characterNames.get(j);
     if( (currentCharacterName.equals(comparedCharacterName)) && i != j){
       characterNames.remove(j);
       j -= 1; //When removing an object, the index of all the succeeding objects is lowered.
               //To avoid skipping an item, we must take one step backwards. 
     }
   } 
  }
  
  //Show names found
  for (int i=0; i < characterNames.size(); i++){
    println(characterNames.get(i)); 
  }
  
}

void findPeopleInScenes(){
   for (int i=0; i < playSummary.size(); i++){
    println(playSummary.get(i)); 
  }
}

void drawScenes(){
   print("hi"); 
}

void drawCharacterLines(){
  for(int i = 0; i < characterNames.size(); i++){
      int playLineStart = -1;
      int playLineEnd = 0;
      String characterDrawing = (String) characterNames.get(i);  //Gets character we are drawing
      for (int j=Integer.parseInt((String)sceneLocation.get(0)); j < fullText.length; j++){
         String[] container= match(fullText[j], "(^[A-Z]*\\s?[A-Z]*\\s?[A-Z]*)+\\."); //Find occurrance of a character name
         if (container != null){ //If there is a name pattern match, check that it is the name we are looking for 
           String[] nameMatch = match(container[0], characterDrawing);
           if (nameMatch != null){ //If it matches the name we are looking for, place line start marker
             playLineStart = j;
           }
           else{  //If it is not a match, then it ends the line
             playLineEnd = j;
             if (playLineStart>=0){
               drawLine(playLineStart, playLineEnd, i);
               playLineStart = -1;
             } 
           }
         }  
       }
  } 
}

void drawLine(int playLineStart, int playLineEnd, int characterNumber){
   strokeCap(SQUARE);
   strokeWeight(lineThickness);
   stroke(#FF0000);
   float strokeBegin = (float)playLineStart * screenPlayRatio;
   float strokeEnd = ((float) playLineEnd) * screenPlayRatio;
   int yPlacement = screenPaddingTop + characterNumber * lineThickness * 2;
   line(strokeBegin, yPlacement, strokeEnd,yPlacement);
}

